/****************************************************************************/
/*                                                                          */
/*                MLGlide 0.1: Interfacing Glide with O'Caml                */
/*                                                                          */
/*              Alexandre Miquel   <Alexandre.Miquel@inria.fr>              */
/*                                                                          */
/* Copyright (c) 1998-1999                                                  */
/* This code can be re-used or modified without any restriction.            */
/* This version is still under development.  There may be bugs and          */
/* inefficient stuff, and I will not be responsible of what can happen      */
/* to you and your environment if you use, read or do whatever you want     */
/* with all this...                                                         */
/*                                                                          */
/*                   ... Enjoy!                                             */
/*                                                                          */
/****************************************************************************/

#include "stub_inc.h"

value gu_aa_draw_triangle_with_clip( value a, value b, value c )
{
  GrVertex ga,gb,gc ;

  FillVertex(ga,a) ;
  FillVertex(gb,b) ;
  FillVertex(gc,c) ;
  SnapVertex(ga) ;
  SnapVertex(gb) ;
  SnapVertex(gc) ;
  guAADrawTriangleWithClip(&ga,&gb,&gc) ;
  return Val_unit ;
}

value gu_draw_triangle_with_clip( value a, value b, value c )
{
  GrVertex ga,gb,gc ;

  FillVertex(ga,a) ;
  FillVertex(gb,b) ;
  FillVertex(gc,c) ;
  SnapVertex(ga) ;
  SnapVertex(gb) ;
  SnapVertex(gc) ;
  guDrawTriangleWithClip(&ga,&gb,&gc) ;
  return Val_unit ;
}

value gu_fog_generate_exp( value density )
{
  GrFog_t table[GR_FOG_TABLE_SIZE] ;
  int i ;
  value str ;

  guFogGenerateExp( table, Float_val(density) ) ;
  str = alloc_string(GR_FOG_TABLE_SIZE) ;
  for(i=0; i<GR_FOG_TABLE_SIZE; i++)
    Byte_u(str,i) = table[i] ;
  return str ;
}

value gu_fog_generate_exp2( value density )
{
  GrFog_t table[GR_FOG_TABLE_SIZE] ;
  int i ;
  value str ;

  guFogGenerateExp2( table, Float_val(density) ) ;
  str = alloc_string(GR_FOG_TABLE_SIZE) ;
  for(i=0; i<GR_FOG_TABLE_SIZE; i++)
    Byte_u(str,i) = table[i] ;
  return str ;
}

value gu_fog_generate_linear( value nearW, value farW )
{
  GrFog_t table[GR_FOG_TABLE_SIZE] ;
  int i ;
  value str ;

  guFogGenerateLinear( table, Float_val(nearW), Float_val(farW) ) ;
  str = alloc_string(GR_FOG_TABLE_SIZE) ;
  for(i=0; i<GR_FOG_TABLE_SIZE; i++)
    Byte_u(str,i) = table[i] ;
  return str ;
}

