/****************************************************************************/
/*                                                                          */
/*                MLGlide 0.1: Interfacing Glide with O'Caml                */
/*                                                                          */
/*              Alexandre Miquel   <Alexandre.Miquel@inria.fr>              */
/*                                                                          */
/* Copyright (c) 1998-1999                                                  */
/* This code can be re-used or modified without any restriction.            */
/* This version is still under development.  There may be bugs and          */
/* inefficient stuff, and I will not be responsible of what can happen      */
/* to you and your environment if you use, read or do whatever you want     */
/* with all this...                                                         */
/*                                                                          */
/*                   ... Enjoy!                                             */
/*                                                                          */
/****************************************************************************/

#include "stub_inc.h"

/****************************************/
/*   Definition of constructor tables   */
/****************************************/

int screen_refresh_table[10] = {
  GR_REFRESH_60Hz,
  GR_REFRESH_70Hz,
  GR_REFRESH_72Hz,
  GR_REFRESH_75Hz,
  GR_REFRESH_80Hz,
  GR_REFRESH_90Hz,
  GR_REFRESH_100Hz,
  GR_REFRESH_85Hz,
  GR_REFRESH_120Hz,
  GR_REFRESH_NONE,
} ;

int screen_resolution_table[15] = {
  GR_RESOLUTION_MIN,
  GR_RESOLUTION_320x200,
  GR_RESOLUTION_320x240,
  GR_RESOLUTION_400x256,
  GR_RESOLUTION_512x384,
  GR_RESOLUTION_640x200,
  GR_RESOLUTION_640x350,
  GR_RESOLUTION_640x400,
  GR_RESOLUTION_640x480,
  GR_RESOLUTION_800x600,
  GR_RESOLUTION_960x720,
  GR_RESOLUTION_856x480,
  GR_RESOLUTION_512x256,
  GR_RESOLUTION_MAX,
  GR_RESOLUTION_NONE
} ;

int combine_function_table[15] = {
  GR_COMBINE_FUNCTION_ZERO,
  GR_COMBINE_FUNCTION_NONE,
  GR_COMBINE_FUNCTION_LOCAL,
  GR_COMBINE_FUNCTION_LOCAL_ALPHA,
  GR_COMBINE_FUNCTION_SCALE_OTHER,
  GR_COMBINE_FUNCTION_BLEND_OTHER,
  GR_COMBINE_FUNCTION_SCALE_OTHER_ADD_LOCAL,
  GR_COMBINE_FUNCTION_SCALE_OTHER_ADD_LOCAL_ALPHA,
  GR_COMBINE_FUNCTION_SCALE_OTHER_MINUS_LOCAL,
  GR_COMBINE_FUNCTION_SCALE_OTHER_MINUS_LOCAL_ADD_LOCAL,
  GR_COMBINE_FUNCTION_BLEND,
  GR_COMBINE_FUNCTION_SCALE_OTHER_MINUS_LOCAL_ADD_LOCAL_ALPHA,
  GR_COMBINE_FUNCTION_SCALE_MINUS_LOCAL_ADD_LOCAL,
  GR_COMBINE_FUNCTION_BLEND_LOCAL,
  GR_COMBINE_FUNCTION_SCALE_MINUS_LOCAL_ADD_LOCAL_ALPHA
} ;

int combine_factor_table[15] = {
  GR_COMBINE_FACTOR_ZERO,
  GR_COMBINE_FACTOR_NONE,
  GR_COMBINE_FACTOR_LOCAL,
  GR_COMBINE_FACTOR_OTHER_ALPHA,
  GR_COMBINE_FACTOR_LOCAL_ALPHA,
  GR_COMBINE_FACTOR_TEXTURE_ALPHA,
  GR_COMBINE_FACTOR_DETAIL_FACTOR,
  GR_COMBINE_FACTOR_LOD_FRACTION,
  GR_COMBINE_FACTOR_ONE,
  GR_COMBINE_FACTOR_ONE_MINUS_LOCAL,
  GR_COMBINE_FACTOR_ONE_MINUS_OTHER_ALPHA,
  GR_COMBINE_FACTOR_ONE_MINUS_LOCAL_ALPHA,
  GR_COMBINE_FACTOR_ONE_MINUS_TEXTURE_ALPHA,
  GR_COMBINE_FACTOR_ONE_MINUS_DETAIL_FACTOR,
  GR_COMBINE_FACTOR_ONE_MINUS_LOD_FRACTION
} ;

int combine_local_table[4] = {
  GR_COMBINE_LOCAL_ITERATED,
  GR_COMBINE_LOCAL_CONSTANT,
  GR_COMBINE_LOCAL_NONE,
  GR_COMBINE_LOCAL_DEPTH
} ;

int combine_other_table[4] = {
  GR_COMBINE_OTHER_ITERATED,
  GR_COMBINE_OTHER_TEXTURE,
  GR_COMBINE_OTHER_CONSTANT,
  GR_COMBINE_OTHER_NONE
} ;

int alpha_source_table[4] = {
  GR_ALPHASOURCE_CC_ALPHA,
  GR_ALPHASOURCE_ITERATED_ALPHA,
  GR_ALPHASOURCE_TEXTURE_ALPHA,
  GR_ALPHASOURCE_TEXTURE_ALPHA_TIMES_ITERATED_ALPHA
} ;

int color_combine_fnc_table[17] = {
  GR_COLORCOMBINE_ZERO,
  GR_COLORCOMBINE_CCRGB,
  GR_COLORCOMBINE_ITRGB,
  GR_COLORCOMBINE_ITRGB_DELTA0,
  GR_COLORCOMBINE_DECAL_TEXTURE,
  GR_COLORCOMBINE_TEXTURE_TIMES_CCRGB,
  GR_COLORCOMBINE_TEXTURE_TIMES_ITRGB,
  GR_COLORCOMBINE_TEXTURE_TIMES_ITRGB_DELTA0,
  GR_COLORCOMBINE_TEXTURE_TIMES_ITRGB_ADD_ALPHA,
  GR_COLORCOMBINE_TEXTURE_TIMES_ALPHA,
  GR_COLORCOMBINE_TEXTURE_TIMES_ALPHA_ADD_ITRGB,
  GR_COLORCOMBINE_TEXTURE_ADD_ITRGB,
  GR_COLORCOMBINE_TEXTURE_SUB_ITRGB,
  GR_COLORCOMBINE_CCRGB_BLEND_ITRGB_ON_TEXALPHA,
  GR_COLORCOMBINE_DIFF_SPEC_A,
  GR_COLORCOMBINE_DIFF_SPEC_B,
  GR_COLORCOMBINE_ONE
} ;

int alpha_blend_fnc_table[12] = {
  GR_BLEND_ZERO,
  GR_BLEND_SRC_ALPHA,
  GR_BLEND_SRC_COLOR,
  GR_BLEND_DST_COLOR,
  GR_BLEND_DST_ALPHA,
  GR_BLEND_ONE,
  GR_BLEND_ONE_MINUS_SRC_ALPHA,
  GR_BLEND_ONE_MINUS_SRC_COLOR,
  GR_BLEND_ONE_MINUS_DST_COLOR,
  GR_BLEND_ONE_MINUS_DST_ALPHA,
  GR_BLEND_ALPHA_SATURATE,
  GR_BLEND_PREFOG_COLOR
} ;

int aspect_ratio_table[7] = {
  GR_ASPECT_8x1,
  GR_ASPECT_4x1,
  GR_ASPECT_2x1,
  GR_ASPECT_1x1,
  GR_ASPECT_1x2,
  GR_ASPECT_1x4,
  GR_ASPECT_1x8
} ;

int buffer_table[6] = {
  GR_BUFFER_FRONTBUFFER,
  GR_BUFFER_BACKBUFFER,
  GR_BUFFER_AUXBUFFER,
  GR_BUFFER_DEPTHBUFFER,
  GR_BUFFER_ALPHABUFFER,
  GR_BUFFER_TRIPLEBUFFER
} ;

int chromakey_mode_table[2] = {
  GR_CHROMAKEY_DISABLE,
  GR_CHROMAKEY_ENABLE
} ;

int cmp_fnc_table[8] = {
  GR_CMP_NEVER,
  GR_CMP_LESS,
  GR_CMP_EQUAL,
  GR_CMP_LEQUAL,
  GR_CMP_GREATER,
  GR_CMP_NOTEQUAL,
  GR_CMP_GEQUAL,
  GR_CMP_ALWAYS
} ;

int color_format_table[2] = {
  GR_COLORFORMAT_ARGB,
  GR_COLORFORMAT_ABGR
} ;

int cull_mode_table[3] = {
  GR_CULL_DISABLE,
  GR_CULL_NEGATIVE,
  GR_CULL_POSITIVE
} ;

int depth_buffer_mode_table[5] = {
  GR_DEPTHBUFFER_DISABLE,
  GR_DEPTHBUFFER_ZBUFFER,
  GR_DEPTHBUFFER_WBUFFER,
  GR_DEPTHBUFFER_ZBUFFER_COMPARE_TO_BIAS,
  GR_DEPTHBUFFER_WBUFFER_COMPARE_TO_BIAS
} ;

int dither_mode_table[3] = {
  GR_DITHER_DISABLE,
  GR_DITHER_2x2,
  GR_DITHER_4x4
} ;

int fog_mode_table[5] = {
  GR_FOG_DISABLE,
  GR_FOG_WITH_ITERATED_ALPHA,
  GR_FOG_WITH_TABLE,
  GR_FOG_MULT2,
  GR_FOG_ADD2
} ;

int lock_table[4] = {
  GR_LFB_READ_ONLY,
  GR_LFB_WRITE_ONLY,
  GR_LFB_IDLE,
  GR_LFB_NOIDLE
} ;

int bypass_mode_table[2] = {
  GR_LFBBYPASS_DISABLE,
  GR_LFBBYPASS_ENABLE
} ;

int lfb_write_mode_table[10] = {
  GR_LFBWRITEMODE_565,
  GR_LFBWRITEMODE_555,
  GR_LFBWRITEMODE_1555,
  GR_LFBWRITEMODE_888,
  GR_LFBWRITEMODE_8888,
  GR_LFBWRITEMODE_565_DEPTH,
  GR_LFBWRITEMODE_555_DEPTH,
  GR_LFBWRITEMODE_1555_DEPTH,
  GR_LFBWRITEMODE_ZA16,
  GR_LFBWRITEMODE_ANY
} ;

int origin_location_table[3] = {
  GR_ORIGIN_UPPER_LEFT,
  GR_ORIGIN_LOWER_LEFT,
  GR_ORIGIN_ANY
} ;

int mipmap_mode_table[3] = {
  GR_MIPMAP_DISABLE,
  GR_MIPMAP_NEAREST,
  GR_MIPMAP_NEAREST_DITHER
} ;

int smoothing_mode_table[2] = {
  GR_SMOOTHING_DISABLE,
  GR_SMOOTHING_ENABLE
} ;

int texture_clamp_mode_table[2] = {
  GR_TEXTURECLAMP_WRAP,
  GR_TEXTURECLAMP_CLAMP
} ;

int texture_combine_fnc_table[11] = {
  GR_TEXTURECOMBINE_ZERO,
  GR_TEXTURECOMBINE_DECAL,
  GR_TEXTURECOMBINE_OTHER,
  GR_TEXTURECOMBINE_ADD,
  GR_TEXTURECOMBINE_MULTIPLY,
  GR_TEXTURECOMBINE_SUBTRACT,
  GR_TEXTURECOMBINE_DETAIL,
  GR_TEXTURECOMBINE_DETAIL_OTHER,
  GR_TEXTURECOMBINE_TRILINEAR_ODD,
  GR_TEXTURECOMBINE_TRILINEAR_EVEN,
  GR_TEXTURECOMBINE_ONE
} ;

int texture_filter_mode_table[2] = {
  GR_TEXTUREFILTER_POINT_SAMPLED,
  GR_TEXTUREFILTER_BILINEAR
} ;

int texture_format_table[18] = {
  GR_TEXFMT_8BIT,
  GR_TEXFMT_RGB_332,
  GR_TEXFMT_YIQ_422,
  GR_TEXFMT_ALPHA_8,
  GR_TEXFMT_INTENSITY_8,
  GR_TEXFMT_ALPHA_INTENSITY_44,
  GR_TEXFMT_P_8,
  GR_TEXFMT_RSVD0,
  GR_TEXFMT_RSVD1,
  GR_TEXFMT_16BIT,
  GR_TEXFMT_ARGB_8332,
  GR_TEXFMT_AYIQ_8422,
  GR_TEXFMT_RGB_565,
  GR_TEXFMT_ARGB_1555,
  GR_TEXFMT_ARGB_4444,
  GR_TEXFMT_ALPHA_INTENSITY_88,
  GR_TEXFMT_AP_88,
  GR_TEXFMT_RSVD2
} ;

int tex_table_table[3] = {
  GR_TEXTABLE_NCC0,
  GR_TEXTABLE_NCC1,
  GR_TEXTABLE_PALETTE
} ;

int ncc_table_mode_table[2] = {
  GR_NCCTABLE_NCC0,
  GR_NCCTABLE_NCC1
} ;

int tex_base_range_table[4] = {
  GR_TEXBASE_256,
  GR_TEXBASE_128,
  GR_TEXBASE_64,
  GR_TEXBASE_32_TO_1
} ;

int lfb_src_fmt_table[10] = {
  GR_LFB_SRC_FMT_565,
  GR_LFB_SRC_FMT_555,
  GR_LFB_SRC_FMT_1555,
  GR_LFB_SRC_FMT_888,
  GR_LFB_SRC_FMT_8888,
  GR_LFB_SRC_FMT_565_DEPTH,
  GR_LFB_SRC_FMT_555_DEPTH,
  GR_LFB_SRC_FMT_1555_DEPTH,
  GR_LFB_SRC_FMT_ZA16,
  GR_LFB_SRC_FMT_RLE16
} ;

int passthru_mode_table[2] = {
  GR_PASSTHRU_SHOW_VGA,
  GR_PASSTHRU_SHOW_SST1
} ;

int hint_table[4] = {
  GR_HINT_STWHINT,
  GR_HINT_FIFOCHECKHINT,
  GR_HINT_FPUPRECISION,
  GR_HINT_ALLOW_MIPMAP_DITHER
} ;

int control_table[4] = {
  GR_CONTROL_ACTIVATE,
  GR_CONTROL_DEACTIVATE,
  GR_CONTROL_RESIZE,
  GR_CONTROL_MOVE
} ;

int mipmap_level_mask_table[3] = {
  GR_MIPMAPLEVELMASK_EVEN,
  GR_MIPMAPLEVELMASK_ODD,
  GR_MIPMAPLEVELMASK_BOTH
} ;
